<?php
/*~ zcache.php
.---------------------------------------------------------------------------.
|  Software: zcache - purge phpBB cache directory                           |
|      Site: http://c61.no-ip.org/forum/index.php                           |
| ------------------------------------------------------------------------- |
|     Author: Serg c61@yandex.ru                                            |
| Copyright (c) 2012, Serg c61@yandex.ru. All Rights Reserved.              |
| ------------------------------------------------------------------------- |
|   License: Distributed under the Lesser General Public License (LGPL)     |
|            http://www.gnu.org/copyleft/lesser.html                        |
| This program is distributed in the hope that it will be useful - WITHOUT  |
| ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     |
| FITNESS FOR A PARTICULAR PURPOSE.                                         |
'---------------------------------------------------------------------------'*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

if ( !$auth->acl_get('a_') )
{
	trigger_error('NO_AUTH_ADMIN');
}

// Version:
$zcache_version = '1.1.0';
//------------------------------------------------------------------------------
//
// c61@yandex.ru : Просмотр и очистка кэша phpBB
// v1.1.0  : 20140324 : адаптировано к phpBB3.1
// v1.0.3  : 20131015 : несущественные улучшения
// v1.0.2  : 20131010 : добавлена перезагрузка страницы после удаления файла/всех файлов
//                      исправление несущественных мелочей
// v1.0.1  : 20130404 : в исключения добавлен потерявшийся в результате применения
//                      любимого китайского метода copy-paste важный файлик queue.php
// v1.0.0  : 20130322 : первый релиз
//
// Параметры:
// Имя      Значение    Описание
// del      файл/1      удалить файл/удалить все файлы
// noshow   1           не показывать таблицу файлов
//
// Примечания:
// 1. .htaccess, index.htm, queue.php, queue.php.lock не удаляются и в списке отсутствуют.
//
//------------------------------------------------------------------------------

// Параметры
$zcache = '.'.DIRECTORY_SEPARATOR.'cache';

$noshow = request_var('noshow',0);

$del = request_var('del','');

function dirs_zcache_glob($path, $pattern = '*', $flags = GLOB_NOSORT)
{
	$matches = array();
	$folders = array(rtrim($path, DIRECTORY_SEPARATOR));
	while ($folder = array_shift($folders)) 
	{
		$matches = array_merge($matches, glob($folder.DIRECTORY_SEPARATOR.$pattern, $flags));
		$moreFolders = glob($folder.DIRECTORY_SEPARATOR.'*', GLOB_ONLYDIR);
		$folders = array_merge($folders, $moreFolders);
	}
	return $matches;
}
  
function zcache_glob($path, $dirs = true)
{
	if ( !$dirs ) return glob($path . DIRECTORY_SEPARATOR . '*.*');
	else          return dirs_zcache_glob($path, '*');
}

if(!empty($del))
{
	switch ($del)
	{
		case 1:
		case 2:
		case 3:
		{
			if($g = zcache_glob($zcache, (($del == 1) ? false : true)))
			{
				arsort($g);
				foreach($g as $filename)
				{
					if(preg_match("|$zcache\/\.htaccess|i",$filename)) continue;
					if(preg_match("|$zcache\/index.htm|i",$filename)) continue;
					if(preg_match("|$zcache\/queue.php|i",$filename)) continue;
					if(preg_match("|$zcache\/queue.php.lock|i",$filename)) continue;
					if($del == 1)
					{
						if(preg_match("|$zcache\/twig|i",$filename)) continue;
					}
					if($del == 2)
					{
						if(!preg_match("|$zcache\/twig|i",$filename)) continue;
					}
					if(is_dir($filename))
					{
						if($del > 2) @rmdir($filename);
					}
					else
					{
						@unlink($filename);
					}
				}
			}
			break;
		}
		default:
		{
			if(!preg_match("|\.\.\/|",$del))
			{
				@unlink($zcache . DIRECTORY_SEPARATOR . $del);
			}
			break;
		}
	}
	if (PHPBB_VERSION >= '3.1.0')
	{
		$self = $request->server('PHP_SELF');
	}
	else
	{
		$self = $_SERVER['PHP_SELF'];
	}
	exit("<meta http-equiv='refresh' content='0; url=$self'>");
}

if(!$noshow)
{
	if($g = zcache_glob($zcache))
	{
		asort($g);

		@header( 'Content-type: text/html; charset=utf-8' );

		echo '<script type="text/javascript">';
		echo 'function yesno(){return confirm("Удалить ?");}';
		echo '</script>';

		echo '<font face="monospace"><table width="100%" border="1" cellspacing="0" cellpadding="2">';
		echo '<tr>';
		echo '<th colspan="4" align="center">Просмотр и очистка кэша phpBB (' . $zcache . ')</th>';
		echo '</tr>';
		echo '<tr>';
		echo '<th colspan="4" align="center">';
		echo '[<a href="zcache.php">Обновить</a>]';
		echo '&nbsp;&nbsp;';
		echo '[<a href="zcache.php?del=1" onclick="javascript:return yesno();">Удалить ' . $zcache . DIRECTORY_SEPARATOR . '*.*</a>]';
		if (in_array($zcache . DIRECTORY_SEPARATOR . 'twig',$g))
		{
		echo '&nbsp;&nbsp;';
		echo '[<a href="zcache.php?del=2" onclick="javascript:return yesno();">Удалить ' . $zcache . DIRECTORY_SEPARATOR . '*' . DIRECTORY_SEPARATOR . '*.*</a>]';
		echo '&nbsp;&nbsp;';
		echo '[<a href="zcache.php?del=3" onclick="javascript:return yesno();">Удалить ВСЁ</a>]';
		}
		echo '</th>';
		echo '</tr>';
		echo '<tr>';
		echo '<th width="1%" align="center">N</th>';
		echo '<th width="59%" align="left">Файл</th>';
		echo '<th width="20%" align="right">Дата/Время</th>';
		echo '<th width="20%" align="right">Размер,&nbsp;байт</th>';
		echo '</tr>';
		$n = 0;
		$totalsize = 0;
		foreach($g as $filename)
		{
			if(preg_match("|$zcache\/\.htaccess|i",$filename)) continue;
			if(preg_match("|$zcache\/index.htm|i",$filename)) continue;
			if(preg_match("|$zcache\/queue.php|i",$filename)) continue;
			if(preg_match("|$zcache\/queue.php.lock|i",$filename)) continue;
			$n++;
			$size = filesize($filename);
			$totalsize += $size;
			$strsize = str_replace(' ','&nbsp;',number_format($size,0,'.',' '));
			$file = str_replace($zcache . DIRECTORY_SEPARATOR,'',$filename);
			echo '<tr>';
			echo '<td width="1%" align="center">' . $n . '</td>';
			echo '<td width="59%">';
			if (!is_dir($filename)) echo '<a href="zcache.php?del=' . $file . '" onclick="javascript:return yesno();">' . $file . '</a>';
			else                    echo $file;
			echo '</td>';
			echo '<td width="20%" align="right">' . date("Y.m.d/H:i:s",fileatime($filename)) . '</td>';
			echo '<td width="20%" align="right">';
			if (!is_dir($filename)) echo $strsize;
			else                    echo 'Dir';
			echo '</td>';
			echo '</tr>';
		}
		$strsize = str_replace(' ','&nbsp;',number_format($totalsize,0,'.',' '));
		echo '<tr>';
		echo '<th width="80%" colspan="3" align="right">Всего</th>';
		echo '<th width="20%" align="right">' . $strsize . '</th>';
		echo '</tr>';
		echo '</table></font>';
		echo '<div width="100%" align="right"><small><i><a href="http://c61.no-ip.org" target="_blank">ZCache</a> v.' . $zcache_version . ' (C) 2013 <a href="mailto:c61@yandex.ru">c61</a></i></small></div>';
	}
}
?>